# Class Cds

java.lang.Object
org.snpeff.interval.Interval
org.snpeff.interval.Marker
org.snpeff.interval.Cds

All Implemented Interfaces:
  `Serializable, Cloneable, Comparable<Interval>, MarkerWithFrame, TxtSerializable`

public class Cds extends Marker implements MarkerWithFrame
CDS: The coding region of a gene, also known as the coding sequence or CDS (from Coding DNA Sequence), is that portion of a gene's DNA or RNA, composed of exons, that codes for protein.

Author:
  pcingola
See Also:
  - Serialized Form

## Field Summary

### Fields inherited from class Marker

`type`

### Fields inherited from class Interval

`chromosomeNameOri, end, id, parent, start, strandMinus`

## Constructor Summary

Constructors
Constructor
Description
`Cds()`
`Cds(Transcript parent, int start, int end, boolean strandMinus, String id)`

## Method Summary

Modifier and Type
Method
Description
`Cds`
`cloneShallow()`
Perform a shallow clone
`boolean`
`frameCorrection(int frameCorrection)`
Correct coordinates according to frame differences
`int`
`getFrame()`
`void`
`serializeParse(MarkerSerializer markerSerializer)`
Parse a line from a serialized file
`String`
`serializeSave(MarkerSerializer markerSerializer)`
Create a string to serialize to a file
`void`
`setFrame(int frame)`
Frame can be {-1, 0, 1, 2}, where '-1' means unknown
`String`
`toString()`

### Methods inherited from class Marker

`adjust, apply, applyDel, applyDup, applyIns, applyMixed, clone, codonTable, compareTo, compareToPos, distance, distanceBases, getParent, getType, idChain, idChain, idChain, includes, intersect, isAdjustIfParentDoesNotInclude, isDeferredAnalysis, isShowWarningIfParentDoesNotInclude, minus, query, query, readTxt, shouldApply, union, variantEffect, variantEffectNonRef`

### Methods inherited from class Interval

`equals, findParent, getChromosome, getChromosomeName, getChromosomeNameOri, getChromosomeNum, getEnd, getGenome, getGenomeName, getId, getStart, getStrand, hashCode, intersects, intersects, intersects, intersects, intersectSize, isCircular, isSameChromo, isStrandMinus, isStrandPlus, isValid, setChromosomeNameOri, setEnd, setId, setParent, setStart, setStrandMinus, shiftCoordinates, size, toStr, toStringAsciiArt, toStrPos`

### Methods inherited from class Object

`equals, finalize, getClass, notify, notifyAll, wait, wait, wait`

## Constructor Details

### Cds

public Cds()

### Cds

public Cds(Transcript parent, int start, int end, boolean strandMinus, String id)

## Method Details

### cloneShallow

public Cds cloneShallow()
Description copied from class: `Marker`
Perform a shallow clone

Overrides:
  `cloneShallow` in class `Marker`

### frameCorrection

public boolean frameCorrection(int frameCorrection)
Correct coordinates according to frame differences

Parameters:
  `frameCorrection` -

### getFrame

public int getFrame()

Specified by:
  `getFrame` in interface `MarkerWithFrame`

### serializeParse

public void serializeParse(MarkerSerializer markerSerializer)
Description copied from class: `Marker`
Parse a line from a serialized file

Specified by:
  `serializeParse` in interface `TxtSerializable`
Overrides:
  `serializeParse` in class `Marker`

### serializeSave

public String serializeSave(MarkerSerializer markerSerializer)
Create a string to serialize to a file

Specified by:
  `serializeSave` in interface `TxtSerializable`
Overrides:
  `serializeSave` in class `Marker`
Returns:

### setFrame

public void setFrame(int frame)
Frame can be {-1, 0, 1, 2}, where '-1' means unknown

Specified by:
  `setFrame` in interface `MarkerWithFrame`
Parameters:
  `frame` -

### toString

public String toString()

Overrides:
  `toString` in class `Marker`